<template>
    <div>
        <form @submit.prevent="editProfile">
            <div class="flex justify-between border-b border-gray-400 px-2 py-3">
                <div class="flex justify-start items-center">
                    <button
                        @click.prevent="$emit('cancel')" 
                        class="text-blue-500 hover:bg-blue-200 hover:text-blue-600 h-8 w-8 rounded-full"
                    >
                        <svg xmlns="http://www.w3.org/2000/svg" class="fill-current" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                            <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M6 18L18 6M6 6l12 12" />
                        </svg>
                    </button>
                </div>
                <div class="flex justify-end items-center">
                    <button
                        class="bg-blue-500 text-white rounded-full font-bold px-4 py-3 focus:outline-none"
                        :class="{'!bg-blue-300' : isDisabled }"
                        :disabled='isDisabled'
                    >
                        Update your profile
                    </button>
                </div>
            </div>

            <div class="px-2">
                <div class="w-full">
                    <label class="flex text-gray-800 font-bold text-2xl">Describe yourself</label>
                    <label class="text-gray-400 text-normal leading-tight mt-2">What makes you special? Don't think too hard, just have fun with it.</label>
                </div>
                <div>
                    <input 
                        type="text" 
                        name="description" 
                        class="text-lg w-full outline-none mt-2 mb-2 p-2 rounded-lg border-2 border-gray-400 focus:border-2 focus:border-blue-400"
                        :class="{'!border-red-600 transition ease-in-out duration-150' : isOverLimit }"
                        placeholder="Your bio"
                        v-model="form.description"
                        autofocus
                    >
                </div>
                
                <div class="flex justify-between">
                    <div class="ml-2">
                        <span v-if="isOverLimit" class="text-red-600 text-sm font-semibold transition ease-in-out duration-150">
                            The description may not be greater than 160 characters
                        </span>
                    </div>

                    <div class="mr-2">
                        <span 
                            class="text-gray-700 text-sm"
                            :class="{'!text-red-600 transition ease-in-out duration-150': isOverLimit }">
                            {{ charCount }}/ {{ charLimit }},
                        </span>
                    </div>
                </div>
            </div>
        </form>
    </div>
</template>
<script>
import { mapActions } from 'vuex'; 
export default {
    props: {
        profile: {
            required: true,
            type: Object
        }
    },

    data() {
        return {
            form: {
                description: '' 
            },
            charLimit: 160,
            error: ''
        }
    },

    computed: {
        isDisabled() {
            return this.form.description != null && this.form.description.length  > this.charLimit;
        },

        isOverLimit() {
            return this.form.description && this.form.description.length > this.charLimit;
        },

        charCount() {
            if(!this.form.description) {
                return '0';
            }
            return this.form.description.length;
        }
    },

    methods: {
        ...mapActions({
            updateProfile: 'profile/updateProfile'
        }),

        editProfile() {
            this.updateProfile({
                username: this.profile.user.username,
                profileData: this.form
            });
            this.$emit('success');
        },
    },

    mounted() {
        this.form.description = this.profile.description;
    },
}
</script>